diff -NurpP --minimal linux-2.6.18/arch/m32r/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/m32r/kernel/traps.c
--- linux-2.6.18/arch/m32r/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m32r/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -195,8 +195,9 @@ static void show_registers(struct pt_reg
 	} else {
 		printk("SPI: %08lx\n", sp);
 	}
-	printk("Process %s (pid: %d, process nr: %d, stackpage=%08lx)",
-		current->comm, current->pid, 0xffff & i, 4096+(unsigned long)current);
+	printk("Process %s (pid: %d[#%u], process nr: %d, stackpage=%08lx)",
+		current->comm, current->pid, current->xid,
+		0xffff & i, 4096+(unsigned long)current);
 
 	/*
 	 * When in-kernel, we also print out the stack and code at the
diff -NurpP --minimal linux-2.6.18/arch/m68k/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/m68k/Kconfig
--- linux-2.6.18/arch/m68k/Kconfig	2006-06-18 04:51:57 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m68k/Kconfig	2006-09-20 17:01:44 +0200
@@ -654,6 +654,8 @@ source "fs/Kconfig"
 
 source "arch/m68k/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/m68k/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/m68k/kernel/process.c
--- linux-2.6.18/arch/m68k/kernel/process.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m68k/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -159,7 +159,8 @@ int kernel_thread(int (*fn)(void *), voi
 
 	{
 	register long retval __asm__ ("d0");
-	register long clone_arg __asm__ ("d1") = flags | CLONE_VM | CLONE_UNTRACED;
+	register long clone_arg __asm__ ("d1") =
+		flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD;
 
 	retval = __NR_clone;
 	__asm__ __volatile__
diff -NurpP --minimal linux-2.6.18/arch/m68k/kernel/ptrace.c linux-2.6.18-vs2.1.1-rc37/arch/m68k/kernel/ptrace.c
--- linux-2.6.18/arch/m68k/kernel/ptrace.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m68k/kernel/ptrace.c	2006-09-25 15:40:02 +0200
@@ -279,6 +279,8 @@ long arch_ptrace(struct task_struct *chi
 		ret = ptrace_request(child, request, addr, data);
 		break;
 	}
+	if (!vx_check(vx_task_xid(child), VX_WATCH_P|VX_IDENT))
+		goto out_tsk;
 
 	return ret;
 out_eio:
diff -NurpP --minimal linux-2.6.18/arch/m68k/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/m68k/kernel/traps.c
--- linux-2.6.18/arch/m68k/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m68k/kernel/traps.c	2006-09-25 17:16:58 +0200
@@ -899,8 +899,8 @@ void show_registers(struct pt_regs *regs
 	printk("d4: %08lx    d5: %08lx    a0: %08lx    a1: %08lx\n",
 	       regs->d4, regs->d5, regs->a0, regs->a1);
 
-	printk("Process %s (pid: %d, task=%p)\n",
-		current->comm, current->pid, current);
+	printk("Process %s (pid: %d[#%u], task=%p)\n",
+		current->comm, current->pid, current->xid, current);
 	addr = (unsigned long)&fp->un;
 	printk("Frame format=%X ", regs->format);
 	switch (regs->format) {
diff -NurpP --minimal linux-2.6.18/arch/m68knommu/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/m68knommu/Kconfig
--- linux-2.6.18/arch/m68knommu/Kconfig	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m68knommu/Kconfig	2006-09-20 17:01:44 +0200
@@ -663,6 +663,8 @@ source "fs/Kconfig"
 
 source "arch/m68knommu/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/m68knommu/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/m68knommu/kernel/process.c
--- linux-2.6.18/arch/m68knommu/kernel/process.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m68knommu/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -122,7 +122,7 @@ void show_regs(struct pt_regs * regs)
 int kernel_thread(int (*fn)(void *), void * arg, unsigned long flags)
 {
 	int retval;
-	long clone_arg = flags | CLONE_VM;
+	long clone_arg = flags | CLONE_VM | CLONE_KTHREAD;
 	mm_segment_t fs;
 
 	fs = get_fs();
diff -NurpP --minimal linux-2.6.18/arch/m68knommu/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/m68knommu/kernel/traps.c
--- linux-2.6.18/arch/m68knommu/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/m68knommu/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -80,8 +80,9 @@ void die_if_kernel(char *str, struct pt_
 	printk(KERN_EMERG "d4: %08lx    d5: %08lx    a0: %08lx    a1: %08lx\n",
 	       fp->d4, fp->d5, fp->a0, fp->a1);
 
-	printk(KERN_EMERG "Process %s (pid: %d, stackpage=%08lx)\n",
-		current->comm, current->pid, PAGE_SIZE+(unsigned long)current);
+	printk(KERN_EMERG "Process %s (pid: %d[#%u], stackpage=%08lx)\n",
+		current->comm, current->pid, current->xid,
+		PAGE_SIZE+(unsigned long)current);
 	show_stack(NULL, (unsigned long *)fp);
 	do_exit(SIGSEGV);
 }
diff -NurpP --minimal linux-2.6.18/arch/mips/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/mips/Kconfig
--- linux-2.6.18/arch/mips/Kconfig	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/Kconfig	2006-09-20 17:01:44 +0200
@@ -2057,6 +2057,8 @@ source "arch/mips/oprofile/Kconfig"
 
 source "arch/mips/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/linux32.c linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/linux32.c
--- linux-2.6.18/arch/mips/kernel/linux32.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/linux32.c	2006-09-25 15:40:02 +0200
@@ -35,6 +35,7 @@
 #include <linux/security.h>
 #include <linux/compat.h>
 #include <linux/vfs.h>
+#include <linux/vs_cvirt.h>
 
 #include <net/sock.h>
 #include <net/scm.h>
@@ -298,7 +299,7 @@ sys32_gettimeofday(struct compat_timeval
 {
 	if (tv) {
 		struct timeval ktv;
-		do_gettimeofday(&ktv);
+		vx_gettimeofday(&ktv);
 		if (put_tv32(tv, &ktv))
 			return -EFAULT;
 	}
@@ -1039,7 +1040,7 @@ asmlinkage long sys32_newuname(struct ne
 	int ret = 0;
 
 	down_read(&uts_sem);
-	if (copy_to_user(name,&system_utsname,sizeof *name))
+	if (copy_to_user(name, vx_new_utsname(), sizeof *name))
 		ret = -EFAULT;
 	up_read(&uts_sem);
 
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/process.c
--- linux-2.6.18/arch/mips/kernel/process.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -270,7 +270,8 @@ long kernel_thread(int (*fn)(void *), vo
 #endif
 
 	/* Ok, create the new process.. */
-	return do_fork(flags | CLONE_VM | CLONE_UNTRACED, 0, &regs, 0, NULL, NULL);
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
+		0, &regs, 0, NULL, NULL);
 }
 
 static struct mips_frame_info {
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/ptrace.c linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/ptrace.c
--- linux-2.6.18/arch/mips/kernel/ptrace.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/ptrace.c	2006-09-25 15:40:02 +0200
@@ -479,6 +479,8 @@ asmlinkage void do_syscall_trace(struct 
 		goto out;
 	if (!test_thread_flag(TIF_SYSCALL_TRACE))
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH_P|VX_IDENT))
+		goto out_tsk;
 
 	/* The 0x80 provides a way for the tracing parent to distinguish
 	   between a syscall stop and SIGTRAP delivery */
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/scall32-o32.S linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/scall32-o32.S
--- linux-2.6.18/arch/mips/kernel/scall32-o32.S	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/scall32-o32.S	2006-09-20 17:01:44 +0200
@@ -630,7 +630,7 @@ einval:	li	v0, -EINVAL
 	sys	sys_mq_timedreceive	5
 	sys	sys_mq_notify		2	/* 4275 */
 	sys	sys_mq_getsetattr	3
-	sys	sys_ni_syscall		0	/* sys_vserver */
+	sys	sys_vserver		3
 	sys	sys_waitid		5
 	sys	sys_ni_syscall		0	/* available, was setaltroot */
 	sys	sys_add_key		5	/* 4280 */
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/scall64-64.S linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/scall64-64.S
--- linux-2.6.18/arch/mips/kernel/scall64-64.S	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/scall64-64.S	2006-09-20 17:01:44 +0200
@@ -434,7 +434,7 @@ sys_call_table:
 	PTR	sys_mq_timedreceive
 	PTR	sys_mq_notify
 	PTR	sys_mq_getsetattr		/* 5235 */
-	PTR	sys_ni_syscall			/* sys_vserver */
+	PTR	sys_vserver
 	PTR	sys_waitid
 	PTR	sys_ni_syscall			/* available, was setaltroot */
 	PTR	sys_add_key
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/scall64-n32.S linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/scall64-n32.S
--- linux-2.6.18/arch/mips/kernel/scall64-n32.S	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/scall64-n32.S	2006-09-20 17:01:44 +0200
@@ -360,7 +360,7 @@ EXPORT(sysn32_call_table)
 	PTR	compat_sys_mq_timedreceive
 	PTR	compat_sys_mq_notify
 	PTR	compat_sys_mq_getsetattr
-	PTR	sys_ni_syscall			/* 6240, sys_vserver */
+	PTR	sys32_vserver			/* 6240 */
 	PTR	sysn32_waitid
 	PTR	sys_ni_syscall			/* available, was setaltroot */
 	PTR	sys_add_key
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/scall64-o32.S linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/scall64-o32.S
--- linux-2.6.18/arch/mips/kernel/scall64-o32.S	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/scall64-o32.S	2006-09-20 17:01:44 +0200
@@ -482,7 +482,7 @@ sys_call_table:
 	PTR	compat_sys_mq_timedreceive
 	PTR	compat_sys_mq_notify		/* 4275 */
 	PTR	compat_sys_mq_getsetattr
-	PTR	sys_ni_syscall			/* sys_vserver */
+	PTR	sys32_vserver
 	PTR	sys32_waitid
 	PTR	sys_ni_syscall			/* available, was setaltroot */
 	PTR	sys_add_key			/* 4280 */
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/syscall.c linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/syscall.c
--- linux-2.6.18/arch/mips/kernel/syscall.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/syscall.c	2006-09-20 17:01:44 +0200
@@ -28,6 +28,7 @@
 #include <linux/shm.h>
 #include <linux/compiler.h>
 #include <linux/module.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/branch.h>
 #include <asm/cachectl.h>
@@ -231,7 +232,7 @@ out:
  */
 asmlinkage int sys_uname(struct old_utsname __user * name)
 {
-	if (name && !copy_to_user(name, &system_utsname, sizeof (*name)))
+	if (name && !copy_to_user(name, vx_new_utsname(), sizeof (*name)))
 		return 0;
 	return -EFAULT;
 }
@@ -242,21 +243,23 @@ asmlinkage int sys_uname(struct old_utsn
 asmlinkage int sys_olduname(struct oldold_utsname __user * name)
 {
 	int error;
+	struct new_utsname *ptr;
 
 	if (!name)
 		return -EFAULT;
 	if (!access_ok(VERIFY_WRITE,name,sizeof(struct oldold_utsname)))
 		return -EFAULT;
 
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,__OLD_UTS_LEN);
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname,ptr->sysname,__OLD_UTS_LEN);
 	error -= __put_user(0,name->sysname+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->nodename,&system_utsname.nodename,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->nodename,ptr->nodename,__OLD_UTS_LEN);
 	error -= __put_user(0,name->nodename+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->release,&system_utsname.release,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->release,ptr->release,__OLD_UTS_LEN);
 	error -= __put_user(0,name->release+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->version,&system_utsname.version,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->version,ptr->version,__OLD_UTS_LEN);
 	error -= __put_user(0,name->version+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->machine,&system_utsname.machine,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->machine,ptr->machine,__OLD_UTS_LEN);
 	error = __put_user(0,name->machine+__OLD_UTS_LEN);
 	error = error ? -EFAULT : 0;
 
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/sysirix.c linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/sysirix.c
--- linux-2.6.18/arch/mips/kernel/sysirix.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/sysirix.c	2006-10-07 04:29:47 +0200
@@ -32,6 +32,7 @@
 #include <linux/security.h>
 #include <linux/syscalls.h>
 #include <linux/resource.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/ptrace.h>
 #include <asm/page.h>
@@ -884,7 +885,7 @@ asmlinkage int irix_getdomainname(char _
 	down_read(&uts_sem);
 	if (len > __NEW_UTS_LEN)
 		len = __NEW_UTS_LEN;
-	err = copy_to_user(name, system_utsname.domainname, len) ? -EFAULT : 0;
+	err = copy_to_user(name, vx_new_uts(domainname), len) ? -EFAULT : 0;
 	up_read(&uts_sem);
 
 	return err;
@@ -1127,11 +1128,11 @@ struct iuname {
 asmlinkage int irix_uname(struct iuname __user *buf)
 {
 	down_read(&uts_sem);
-	if (copy_from_user(system_utsname.sysname, buf->sysname, 65)
-	    || copy_from_user(system_utsname.nodename, buf->nodename, 65)
-	    || copy_from_user(system_utsname.release, buf->release, 65)
-	    || copy_from_user(system_utsname.version, buf->version, 65)
-	    || copy_from_user(system_utsname.machine, buf->machine, 65)) {
+	if (copy_from_user(vx_new_uts(sysname), buf->sysname, 65)
+	    || copy_from_user(vx_new_uts(nodename), buf->nodename, 65)
+	    || copy_from_user(vx_new_uts(release), buf->release, 65)
+	    || copy_from_user(vx_new_uts(version), buf->version, 65)
+	    || copy_from_user(vx_new_uts(machine), buf->machine, 65)) {
 		return -EFAULT;
 	}
 	up_read(&uts_sem);
diff -NurpP --minimal linux-2.6.18/arch/mips/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/traps.c
--- linux-2.6.18/arch/mips/kernel/traps.c	2006-09-20 16:57:58 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/mips/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -266,8 +266,9 @@ void show_registers(struct pt_regs *regs
 {
 	show_regs(regs);
 	print_modules();
-	printk("Process %s (pid: %d, threadinfo=%p, task=%p)\n",
-	        current->comm, current->pid, current_thread_info(), current);
+	printk("Process %s (pid: %d[#%u], threadinfo=%p, task=%p)\n",
+		current->comm, current->pid, current->xid,
+		current_thread_info(), current);
 	show_stack(current, (long *) regs->regs[29]);
 	show_trace(current, (long *) regs->regs[29]);
 	show_code((unsigned int *) regs->cp0_epc);
diff -NurpP --minimal linux-2.6.18/arch/parisc/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/parisc/Kconfig
--- linux-2.6.18/arch/parisc/Kconfig	2006-09-20 16:58:00 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/parisc/Kconfig	2006-09-20 17:01:44 +0200
@@ -257,6 +257,8 @@ source "arch/parisc/oprofile/Kconfig"
 
 source "arch/parisc/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/parisc/hpux/sys_hpux.c linux-2.6.18-vs2.1.1-rc37/arch/parisc/hpux/sys_hpux.c
--- linux-2.6.18/arch/parisc/hpux/sys_hpux.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/parisc/hpux/sys_hpux.c	2006-09-20 17:01:44 +0200
@@ -33,6 +33,7 @@
 #include <linux/utsname.h>
 #include <linux/vfs.h>
 #include <linux/vmalloc.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/errno.h>
 #include <asm/pgalloc.h>
@@ -266,15 +267,15 @@ static int hpux_uname(struct hpux_utsnam
 
 	down_read(&uts_sem);
 
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,HPUX_UTSLEN-1);
+	error = __copy_to_user(&name->sysname,vx_new_uts(sysname),HPUX_UTSLEN-1);
 	error |= __put_user(0,name->sysname+HPUX_UTSLEN-1);
-	error |= __copy_to_user(&name->nodename,&system_utsname.nodename,HPUX_UTSLEN-1);
+	error |= __copy_to_user(&name->nodename,vx_new_uts(nodename),HPUX_UTSLEN-1);
 	error |= __put_user(0,name->nodename+HPUX_UTSLEN-1);
-	error |= __copy_to_user(&name->release,&system_utsname.release,HPUX_UTSLEN-1);
+	error |= __copy_to_user(&name->release,vx_new_uts(release),HPUX_UTSLEN-1);
 	error |= __put_user(0,name->release+HPUX_UTSLEN-1);
-	error |= __copy_to_user(&name->version,&system_utsname.version,HPUX_UTSLEN-1);
+	error |= __copy_to_user(&name->version,vx_new_uts(version),HPUX_UTSLEN-1);
 	error |= __put_user(0,name->version+HPUX_UTSLEN-1);
-	error |= __copy_to_user(&name->machine,&system_utsname.machine,HPUX_UTSLEN-1);
+	error |= __copy_to_user(&name->machine,vx_new_uts(machine),HPUX_UTSLEN-1);
 	error |= __put_user(0,name->machine+HPUX_UTSLEN-1);
 
 	up_read(&uts_sem);
@@ -373,8 +374,8 @@ int hpux_utssys(char *ubuf, int n, int t
 		/*  TODO:  print a warning about using this?  */
 		down_write(&uts_sem);
 		error = -EFAULT;
-		if (!copy_from_user(system_utsname.sysname, ubuf, len)) {
-			system_utsname.sysname[len] = 0;
+		if (!copy_from_user(vx_new_uts(sysname), ubuf, len)) {
+			vx_new_uts(sysname)[len] = 0;
 			error = 0;
 		}
 		up_write(&uts_sem);
@@ -400,8 +401,8 @@ int hpux_utssys(char *ubuf, int n, int t
 		/*  TODO:  print a warning about this?  */
 		down_write(&uts_sem);
 		error = -EFAULT;
-		if (!copy_from_user(system_utsname.release, ubuf, len)) {
-			system_utsname.release[len] = 0;
+		if (!copy_from_user(vx_new_uts(release), ubuf, len)) {
+			vx_new_uts(release)[len] = 0;
 			error = 0;
 		}
 		up_write(&uts_sem);
@@ -422,13 +423,13 @@ int hpux_getdomainname(char *name, int l
  	
  	down_read(&uts_sem);
  	
-	nlen = strlen(system_utsname.domainname) + 1;
+	nlen = strlen(vx_new_uts(domainname)) + 1;
 
 	if (nlen < len)
 		len = nlen;
 	if(len > __NEW_UTS_LEN)
 		goto done;
-	if(copy_to_user(name, system_utsname.domainname, len))
+	if(copy_to_user(name, vx_new_uts(domainname), len))
 		goto done;
 	err = 0;
 done:
diff -NurpP --minimal linux-2.6.18/arch/parisc/kernel/entry.S linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/entry.S
--- linux-2.6.18/arch/parisc/kernel/entry.S	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/entry.S	2006-09-25 15:40:02 +0200
@@ -764,6 +764,7 @@ fault_vector_11:
 
 #define CLONE_VM 0x100	/* Must agree with <linux/sched.h> */
 #define CLONE_UNTRACED 0x00800000
+#define CLONE_KTHREAD 0x10000000
 
 	.export __kernel_thread, code
 	.import do_fork
diff -NurpP --minimal linux-2.6.18/arch/parisc/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/process.c
--- linux-2.6.18/arch/parisc/kernel/process.c	2006-06-18 04:52:15 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -173,7 +173,7 @@ pid_t kernel_thread(int (*fn)(void *), v
 	 *	  kernel_thread can become a #define.
 	 */
 
-	return __kernel_thread(fn, arg, flags);
+	return __kernel_thread(fn, arg, flags | CLONE_KTHREAD);
 }
 EXPORT_SYMBOL(kernel_thread);
 
diff -NurpP --minimal linux-2.6.18/arch/parisc/kernel/sys_parisc32.c linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/sys_parisc32.c
--- linux-2.6.18/arch/parisc/kernel/sys_parisc32.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/sys_parisc32.c	2006-09-25 15:40:02 +0200
@@ -201,11 +201,11 @@ static inline long get_ts32(struct times
 asmlinkage int
 sys32_gettimeofday(struct compat_timeval __user *tv, struct timezone __user *tz)
 {
-    extern void do_gettimeofday(struct timeval *tv);
+    extern void vx_gettimeofday(struct timeval *tv);
 
     if (tv) {
 	    struct timeval ktv;
-	    do_gettimeofday(&ktv);
+	    vx_gettimeofday(&ktv);
 	    if (put_compat_timeval(tv, &ktv))
 		    return -EFAULT;
     }
@@ -598,6 +598,7 @@ asmlinkage int sys32_sysinfo(struct sysi
 
 	do {
 		seq = read_seqbegin(&xtime_lock);
+		/* FIXME: requires vx virtualization */
 		val.uptime = jiffies / HZ;
 
 		val.loads[0] = avenrun[0] << (SI_LOAD_SHIFT - FSHIFT);
diff -NurpP --minimal linux-2.6.18/arch/parisc/kernel/syscall_table.S linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/syscall_table.S
--- linux-2.6.18/arch/parisc/kernel/syscall_table.S	2006-06-18 04:52:15 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/syscall_table.S	2006-09-20 17:01:44 +0200
@@ -368,7 +368,7 @@
 	ENTRY_COMP(mbind)		/* 260 */
 	ENTRY_COMP(get_mempolicy)
 	ENTRY_COMP(set_mempolicy)
-	ENTRY_SAME(ni_syscall)	/* 263: reserved for vserver */
+	ENTRY_DIFF(vserver)
 	ENTRY_SAME(add_key)
 	ENTRY_SAME(request_key)		/* 265 */
 	ENTRY_SAME(keyctl)
diff -NurpP --minimal linux-2.6.18/arch/parisc/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/traps.c
--- linux-2.6.18/arch/parisc/kernel/traps.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/parisc/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -209,8 +209,9 @@ void die_if_kernel(char *str, struct pt_
 		if (err == 0)
 			return; /* STFU */
 
-		printk(KERN_CRIT "%s (pid %d): %s (code %ld) at " RFMT "\n",
-			current->comm, current->pid, str, err, regs->iaoq[0]);
+		printk(KERN_CRIT "%s (pid %d[#%u]): %s (code %ld) at " RFMT "\n",
+			current->comm, current->pid, current->xid,
+			str, err, regs->iaoq[0]);
 #ifdef PRINT_USER_FAULTS
 		/* XXX for debugging only */
 		show_regs(regs);
@@ -241,8 +242,8 @@ void die_if_kernel(char *str, struct pt_
 	if (!console_drivers)
 		pdc_console_restart();
 	
-	printk(KERN_CRIT "%s (pid %d): %s (code %ld)\n",
-		current->comm, current->pid, str, err);
+	printk(KERN_CRIT "%s (pid %d[#%u]): %s (code %ld)\n",
+		current->comm, current->pid, current->xid, str, err);
 	show_regs(regs);
 
 	/* Wot's wrong wif bein' racy? */
diff -NurpP --minimal linux-2.6.18/arch/powerpc/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/powerpc/Kconfig
--- linux-2.6.18/arch/powerpc/Kconfig	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/powerpc/Kconfig	2006-09-20 17:01:44 +0200
@@ -1069,6 +1069,8 @@ endmenu
 
 source "arch/powerpc/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 config KEYS_COMPAT
diff -NurpP --minimal linux-2.6.18/arch/powerpc/kernel/asm-offsets.c linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/asm-offsets.c
--- linux-2.6.18/arch/powerpc/kernel/asm-offsets.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/asm-offsets.c	2006-09-25 15:40:02 +0200
@@ -229,6 +229,7 @@ int main(void)
 
 	DEFINE(CLONE_VM, CLONE_VM);
 	DEFINE(CLONE_UNTRACED, CLONE_UNTRACED);
+	DEFINE(CLONE_KTHREAD, CLONE_KTHREAD);
 
 #ifndef CONFIG_PPC64
 	DEFINE(MM_PGD, offsetof(struct mm_struct, pgd));
diff -NurpP --minimal linux-2.6.18/arch/powerpc/kernel/misc_32.S linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/misc_32.S
--- linux-2.6.18/arch/powerpc/kernel/misc_32.S	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/misc_32.S	2006-09-25 15:40:02 +0200
@@ -823,7 +823,7 @@ _GLOBAL(kernel_thread)
 	mr	r30,r3		/* function */
 	mr	r31,r4		/* argument */
 	ori	r3,r5,CLONE_VM	/* flags */
-	oris	r3,r3,CLONE_UNTRACED>>16
+	oris	r3,r3,(CLONE_UNTRACED|CLONE_KTHREAD)>>16
 	li	r4,0		/* new sp (unused) */
 	li	r0,__NR_clone
 	sc
diff -NurpP --minimal linux-2.6.18/arch/powerpc/kernel/misc_64.S linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/misc_64.S
--- linux-2.6.18/arch/powerpc/kernel/misc_64.S	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/misc_64.S	2006-09-25 15:40:02 +0200
@@ -472,7 +472,7 @@ _GLOBAL(kernel_thread)
 	mr	r29,r3
 	mr	r30,r4
 	ori	r3,r5,CLONE_VM	/* flags */
-	oris	r3,r3,(CLONE_UNTRACED>>16)
+	oris	r3,r3,(CLONE_UNTRACED|CLONE_KTHREAD)>>16
 	li	r4,0		/* new sp (unused) */
 	li	r0,__NR_clone
 	sc
diff -NurpP --minimal linux-2.6.18/arch/powerpc/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/process.c
--- linux-2.6.18/arch/powerpc/kernel/process.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/process.c	2006-09-20 17:01:44 +0200
@@ -431,8 +431,9 @@ void show_regs(struct pt_regs * regs)
 	trap = TRAP(regs);
 	if (trap == 0x300 || trap == 0x600)
 		printk("DAR: "REG", DSISR: "REG"\n", regs->dar, regs->dsisr);
-	printk("TASK = %p[%d] '%s' THREAD: %p",
-	       current, current->pid, current->comm, task_thread_info(current));
+	printk("TASK = %p[%d,#%u] '%s' THREAD: %p",
+	       current, current->pid, current->xid,
+	       current->comm, task_thread_info(current));
 
 #ifdef CONFIG_SMP
 	printk(" CPU: %d", smp_processor_id());
diff -NurpP --minimal linux-2.6.18/arch/powerpc/kernel/sys_ppc32.c linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/sys_ppc32.c
--- linux-2.6.18/arch/powerpc/kernel/sys_ppc32.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/sys_ppc32.c	2006-09-25 15:40:02 +0200
@@ -266,7 +266,7 @@ asmlinkage long compat_sys_gettimeofday(
 {
 	if (tv) {
 		struct timeval ktv;
-		do_gettimeofday(&ktv);
+		vx_gettimeofday(&ktv);
 		if (put_tv32(tv, &ktv))
 			return -EFAULT;
 	}
diff -NurpP --minimal linux-2.6.18/arch/powerpc/kernel/syscalls.c linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/syscalls.c
--- linux-2.6.18/arch/powerpc/kernel/syscalls.c	2006-06-18 04:52:17 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/syscalls.c	2006-09-20 17:01:44 +0200
@@ -36,6 +36,7 @@
 #include <linux/file.h>
 #include <linux/init.h>
 #include <linux/personality.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -260,7 +261,7 @@ long ppc_newuname(struct new_utsname __u
 	int err = 0;
 
 	down_read(&uts_sem);
-	if (copy_to_user(name, &system_utsname, sizeof(*name)))
+	if (copy_to_user(name, vx_new_utsname(), sizeof(*name)))
 		err = -EFAULT;
 	up_read(&uts_sem);
 	if (!err)
@@ -273,7 +274,7 @@ int sys_uname(struct old_utsname __user 
 	int err = 0;
 	
 	down_read(&uts_sem);
-	if (copy_to_user(name, &system_utsname, sizeof(*name)))
+	if (copy_to_user(name, vx_new_utsname(), sizeof(*name)))
 		err = -EFAULT;
 	up_read(&uts_sem);
 	if (!err)
@@ -284,25 +285,22 @@ int sys_uname(struct old_utsname __user 
 int sys_olduname(struct oldold_utsname __user *name)
 {
 	int error;
+	struct new_utsname *ptr;
 
 	if (!access_ok(VERIFY_WRITE, name, sizeof(struct oldold_utsname)))
 		return -EFAULT;
   
 	down_read(&uts_sem);
-	error = __copy_to_user(&name->sysname, &system_utsname.sysname,
-			       __OLD_UTS_LEN);
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname, ptr->sysname, __OLD_UTS_LEN);
 	error |= __put_user(0, name->sysname + __OLD_UTS_LEN);
-	error |= __copy_to_user(&name->nodename, &system_utsname.nodename,
-				__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->nodename, ptr->nodename, __OLD_UTS_LEN);
 	error |= __put_user(0, name->nodename + __OLD_UTS_LEN);
-	error |= __copy_to_user(&name->release, &system_utsname.release,
-				__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->release, ptr->release, __OLD_UTS_LEN);
 	error |= __put_user(0, name->release + __OLD_UTS_LEN);
-	error |= __copy_to_user(&name->version, &system_utsname.version,
-				__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->version, ptr->version, __OLD_UTS_LEN);
 	error |= __put_user(0, name->version + __OLD_UTS_LEN);
-	error |= __copy_to_user(&name->machine, &system_utsname.machine,
-				__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->machine, ptr->machine, __OLD_UTS_LEN);
 	error |= override_machine(name->machine);
 	up_read(&uts_sem);
 
diff -NurpP --minimal linux-2.6.18/arch/powerpc/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/traps.c
--- linux-2.6.18/arch/powerpc/kernel/traps.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -861,8 +861,9 @@ void nonrecoverable_exception(struct pt_
 
 void trace_syscall(struct pt_regs *regs)
 {
-	printk("Task: %p(%d), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
-	       current, current->pid, regs->nip, regs->link, regs->gpr[0],
+	printk("Task: %p(%d[#%u]), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
+	       current, current->pid, current->xid,
+	       regs->nip, regs->link, regs->gpr[0],
 	       regs->ccr&0x10000000?"Error=":"", regs->gpr[3], print_tainted());
 }
 
diff -NurpP --minimal linux-2.6.18/arch/powerpc/kernel/vdso.c linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/vdso.c
--- linux-2.6.18/arch/powerpc/kernel/vdso.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/powerpc/kernel/vdso.c	2006-09-20 19:58:24 +0200
@@ -22,6 +22,7 @@
 #include <linux/elf.h>
 #include <linux/security.h>
 #include <linux/bootmem.h>
+#include <linux/vs_memory.h>
 
 #include <asm/pgtable.h>
 #include <asm/system.h>
@@ -293,7 +294,7 @@ int arch_setup_additional_pages(struct l
 
 	/* Put vDSO base into mm struct and account for memory usage */
 	current->mm->context.vdso_base = vdso_base;
-	mm->total_vm += (vma->vm_end - vma->vm_start) >> PAGE_SHIFT;
+	vx_vmpages_add(mm, (vma->vm_end - vma->vm_start) >> PAGE_SHIFT);
 	up_write(&mm->mmap_sem);
 	return 0;
 
diff -NurpP --minimal linux-2.6.18/arch/ppc/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/ppc/Kconfig
--- linux-2.6.18/arch/ppc/Kconfig	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ppc/Kconfig	2006-09-20 17:01:44 +0200
@@ -1418,6 +1418,8 @@ source "arch/powerpc/oprofile/Kconfig"
 
 source "arch/ppc/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/ppc/kernel/asm-offsets.c linux-2.6.18-vs2.1.1-rc37/arch/ppc/kernel/asm-offsets.c
--- linux-2.6.18/arch/ppc/kernel/asm-offsets.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ppc/kernel/asm-offsets.c	2006-09-25 15:40:02 +0200
@@ -121,6 +121,7 @@ main(void)
 	DEFINE(TRAP, STACK_FRAME_OVERHEAD+offsetof(struct pt_regs, trap));
 	DEFINE(CLONE_VM, CLONE_VM);
 	DEFINE(CLONE_UNTRACED, CLONE_UNTRACED);
+	DEFINE(CLONE_KTHREAD, CLONE_KTHREAD);
 	DEFINE(MM_PGD, offsetof(struct mm_struct, pgd));
 
 	/* About the CPU features table */
diff -NurpP --minimal linux-2.6.18/arch/ppc/kernel/misc.S linux-2.6.18-vs2.1.1-rc37/arch/ppc/kernel/misc.S
--- linux-2.6.18/arch/ppc/kernel/misc.S	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ppc/kernel/misc.S	2006-09-25 15:40:02 +0200
@@ -1010,7 +1010,7 @@ _GLOBAL(kernel_thread)
 	mr	r30,r3		/* function */
 	mr	r31,r4		/* argument */
 	ori	r3,r5,CLONE_VM	/* flags */
-	oris	r3,r3,CLONE_UNTRACED>>16
+	oris	r3,r3,(CLONE_UNTRACED|CLONE_KTHREAD)>>16
 	li	r4,0		/* new sp (unused) */
 	li	r0,__NR_clone
 	sc
diff -NurpP --minimal linux-2.6.18/arch/ppc/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/ppc/kernel/traps.c
--- linux-2.6.18/arch/ppc/kernel/traps.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/ppc/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -746,8 +746,9 @@ void nonrecoverable_exception(struct pt_
 
 void trace_syscall(struct pt_regs *regs)
 {
-	printk("Task: %p(%d), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
-	       current, current->pid, regs->nip, regs->link, regs->gpr[0],
+	printk("Task: %p(%d[#%u]), PC: %08lX/%08lX, Syscall: %3ld, Result: %s%ld    %s\n",
+	       current, current->pid, current->xid,
+	       regs->nip, regs->link, regs->gpr[0],
 	       regs->ccr&0x10000000?"Error=":"", regs->gpr[3], print_tainted());
 }
 
diff -NurpP --minimal linux-2.6.18/arch/s390/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/s390/Kconfig
--- linux-2.6.18/arch/s390/Kconfig	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/s390/Kconfig	2006-09-20 17:01:44 +0200
@@ -491,6 +491,8 @@ source "arch/s390/oprofile/Kconfig"
 
 source "arch/s390/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/s390/kernel/compat_linux.c linux-2.6.18-vs2.1.1-rc37/arch/s390/kernel/compat_linux.c
--- linux-2.6.18/arch/s390/kernel/compat_linux.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/s390/kernel/compat_linux.c	2006-09-25 15:40:02 +0200
@@ -596,7 +596,7 @@ asmlinkage long sys32_gettimeofday(struc
 {
 	if (tv) {
 		struct timeval ktv;
-		do_gettimeofday(&ktv);
+		vx_gettimeofday(&ktv);
 		if (put_tv32(tv, &ktv))
 			return -EFAULT;
 	}
